// Copyright 2003-2012, Deep IT, Uncle MiF
// All rights reserved

var content;
var currentDictionary;// text label on front side
var activeDictionary;// active dictionary name
var activeMorphology;
var search;
var dictionaries;
var morphology;
var version;

// internal
var verbose = 0;

var opacity;
var translationHistory;
var curIdx = -1;

window.linkedWord = ''; 

function translateLinkedWord()
{
 if (window.linkedWord)
 {
  search.value = window.linkedWord;
	 window.linkedWord = ''; 
	 window.translate();
	}
}

function setupOutlets()
{
	translationHistory = new Array();
	content = document.getElementById('tid_content');
	currentDictionary = document.getElementById('tid_currentDictionary');
	search = document.getElementById('tid_searchfield');
	dictionaries = document.getElementById('tid_popup');
	morphology = document.getElementById('tid_morphology');
	version = document.getElementById('tid_version');
}

function trunc(str)
{
	return str;
}

function createkey(key)
{
 return createInstancePreferenceKey(key); 
}

function dictionary(dName, alias, selected)
{
	var d = document.createElement('option');
	d.setAttribute('apple-group','popup');
	d.setAttribute('value',dName);
	if (dName == selected)
		d.setAttribute('selected',true);
	d.innerHTML = alias;
	return d;
}

function morphologyFactory(mName, selected)
{
	var m = document.createElement('option');
	m.setAttribute('value',mName);
	if (mName == selected)
		m.setAttribute('selected',true);
	m.innerHTML = getLocalizedString(mName);
	return m;
}

function morphologyChanged()
{
	var mName = morphology.options[morphology.selectedIndex].value;
	window.MDictPlugin.morphologyChanged(mName);
	widget.setPreferenceForKey(mName,createkey('activeMorphology'));
	activeMorphology = mName;
	window.translate();
}

function buildDictList()
{
	if (window.MDictPlugin)
	{
		while (dictionaries.options.length > 1)
			dictionaries.removeChild(dictionaries.options[1]);
		var ads = MDictPlugin.availableDictionaries();
		var i;
		if (window.widget)
		{
			activeDictionary = widget.preferenceForKey(createkey('activeDictionary'));
			if (activeDictionary)
			{
				currentDictionary.innerHTML = trunc(MDictPlugin.dictionaryAlias(activeDictionary));
			}
		}
		for (i = 0; i < ads.length; i++)
		{
			var dName = ads[i].replace(/\.dict$/i,''); 
			var dName = dName.replace(/\.tid$/i,''); 
			dictionaries.appendChild(dictionary(dName,MDictPlugin.dictionaryAlias(dName),activeDictionary));
		}
	}
}

function softReload()
{
	buildDictList();
}

function load()
{
	setupParts();
	setupOutlets();
	opacity = content.style.opacity;
	content.style.opacity = 0;
	search.setAttribute('placeholder',getLocalizedString('Lookup Word'));
	if (window.MDictPlugin)
	{
		version.innerHTML = getLocalizedString('ver') + ' ' + MDictPlugin.widgetVersion();

		buildDictList();

		while (morphology.options.length)
			morphology.removeChild(morphology.options[0]);
		var ams = new Array('All available','None','English','Russian','German','French','Spanish');
		var i;
		if (window.widget)
		{
			activeMorphology = widget.preferenceForKey(createkey('activeMorphology'));
			if (activeMorphology)
				window.MDictPlugin.morphologyChanged(activeMorphology);
		}
		for (i = 0; i < ams.length; i++)
		{
			morphology.appendChild(morphologyFactory(ams[i],activeMorphology));
		}
	}
}

function dictionaryChanged()
{
	activeDictionary = dictionaries.options[dictionaries.selectedIndex].value;
	if (window.MDictPlugin)
		currentDictionary.innerHTML = trunc(MDictPlugin.dictionaryAlias(activeDictionary));
	if (window.widget)
		widget.setPreferenceForKey(activeDictionary,createkey('activeDictionary'));
	window.translate();
}

function addHistory(word)
{
	if (curWord() == word)
		return;
	if (curIdx != -1 && curIdx < translationHistory.length)
		translationHistory = translationHistory.splice(0,curIdx+1);
	translationHistory.push(word);
	curIdx = translationHistory.length - 1;
	if (verbose) alert('addHistory(): '+word+', count: '+translationHistory.length+', curIdx = '+curIdx);
}

function curWord()
{
	if (!translationHistory.length || curIdx >= translationHistory.length)
		return '';
	if (verbose) alert('curWord(): '+translationHistory[curIdx]+', curIdx = '+curIdx);
	return translationHistory[curIdx];
}

function prevWord()
{
	if (!translationHistory.length)
		return '';
	curIdx--;
	if (curIdx < 0)
		curIdx = 0;
	if (verbose) alert('prevWord(): '+translationHistory[curIdx]+', curIdx = '+curIdx);
	search.value = translationHistory[curIdx];
	search.focus();
	window.translate();
}

function nextWord()
{
	if (!translationHistory.length)
		return '';
	curIdx++;
	if (curIdx >= translationHistory.length)
		curIdx = translationHistory.length - 1;
	if (verbose) alert('nextWord(): '+translationHistory[curIdx]);
	search.value = translationHistory[curIdx];
	search.focus();
	window.translate();
}

function translateWord(aWord)
{
	search.value = aWord;
	window.translate();
}

function translate()
{
	content.style.opacity = 0;
	content.innerHTML = '';
	if (window.MDictPlugin && activeDictionary)
	{
		var result = MDictPlugin.translateWord(search.value, activeDictionary);
		if (result)
		{
			links = new Array();
			if (/<link [^>]+>/.test(result))	
				links = result.match(/<link [^>]+>/g);
			var i;
			for (i = 0; i < links.length; i++)
			{
				result = result.replace(links[i],'');
			}
			result = result.replace(/(>|<br>|\n|[\s\(\)\[\]\{\},\.;'`])([A-Za-z\-]+?)(?=[\s\(\)\[\]\{\},\.;\?'`]|<br>|\n|<)/g,'$1<font class="cengtext">$2</font>');
			result = result.replace(/(\s|<br>|\n|\()_([^_\.\s<>]+)/g,'$1<font class="ccommentary"><i>$2</i></font>');
			result = result.replace(/((?:<br>|\n|\t| )\d+)>/gi,'$1)');
			result = result.replace(/^(\d+)>/g,'$1)');
			result = result.replace(/((?:\n|\t|<br>| )\d+)&gt;/gi,'$1)');
			while (/(<[^<>]*)<font\s+[^<>]*>([^<>]*)<\/font>/.test(result))
				result = result.replace(/(<[^<>]*)<font\s+[^<>]*>([^<>]*)<\/font>/g,'$1$2');
			result = result.replace(/(?:\[:\[|\{)([^\{\}\n]+)(?:\]:\]|\})/g,"<a style='color:#2A34B8;' onclick='var word = this.innerHTML; word = word.replace(/<[^<>]*>/g,\"\"); translateWord(word);'>$1</a>");

			for (i = 0; i < links.length; i++)
			{
				result = links[i] + result;
			}
		}
		content.innerHTML = result;
		if (verbose) alert(result);
		if (content.innerHTML)
		{
			content.style.opacity = opacity;
			addHistory(search.value);
		}
		else
			content.style.opacity = 0;
	}
	if (window.MDictPlugin)
	{
		window.MDictPlugin.scheduleQueryForWord(search.value);
	}
	search.focus();
}

function didLoadServices(aTSN)
{
	if (typeof(aTSN) == 'undefined' || !aTSN)
  aTSN = 0;
 if (window.MDictPlugin)
 {
  var result = window.MDictPlugin.servicesResultForTSN(aTSN);
  if (result)
  {
			//result = result.replace(/<img\s+[^>]+>/gi,'');
			result = result.replace(/<link\s+[^>]+>/gi,'');
			var oldContent = (content.innerHTML) ? content.innerHTML + "<hr noshade size=1 style='margin-top: 3px; margin-bottom: 3px; padding: 0px; height: 1px; border: 0;'>" : '';
			content.innerHTML = oldContent + result;
			if (content.innerHTML)
			{
				content.style.opacity = opacity;
				addHistory(search.value);
			}
			else
				content.style.opacity = 0;
		}
	}
}

function remove()
{
	widget.setPreferenceForKey(null, createkey('activeDictionary'));
}

function hide()
{
	// your widget has just been hidden stop any timers to
	// prevent cpu usage
}

function show()
{
	// your widget has just been shown.  restart any timers
	// and adjust your interface as needed
}

function showBack(event)
{
	// your widget needs to show the back

	var front = document.getElementById("tid_front");
	var back = document.getElementById("tid_back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
	dictionaries.focus();
}

function showFront(event)
{
	// your widget needs to show the front

	var front = document.getElementById("tid_front");
	var back = document.getElementById("tid_back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
	
	search.focus();
}

if (window.widget)
{
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
}


function onMDictButtonClick() 
{
	if (window.widget)
		MDictPlugin.openTIForWord(search.value);
}


function onMiFClick(event) 
{
	if (window.widget)
	{
		lang = getLocalizedString('lang');
		widget.openURL( lang == 'ru' ? 'http://mac.translateit.ru/ru/' : ( lang == 'fr' ? 'http://mac.gettranslateit.com/fr/' : ( lang == 'de' ? 'http://mac.gettranslateit.com/de/' : 'http://mac.gettranslateit.com/en/')));
	}
}

